DESCRIPTION = "TensorFlow’s lightweight solution for embedded devices"
HOMEPAGE = "https://www.tensorflow.org/lite"
LICENSE = "Apache-2.0"
LIC_FILES_CHKSUM = "file://LICENSE;md5=4158a261ca7f2525513e31ba9c50ae98"

DEPENDS = "zlib"

SRC_URI = " \
    git://github.com/tensorflow/tensorflow;destsuffix=git/;branch=r2.8;protocol=https \
    file://fix-to-cmake.patch \
    file://tensorflow2-lite.pc.in \
    file://0001-Downgrade-CMake-version-to-3.15.patch \
"

SRCREV = "3f878cff5b698b82eea85db2b60d65a2e320850e"

inherit cmake pkgconfig

S = "${WORKDIR}/git"

do_configure() {
    cmake \
    -DCMAKE_SYSTEM_NAME=Linux \
    -DCMAKE_SYSTEM_PROCESSOR=armv7 \
    -DTFLITE_C_BUILD_SHARED_LIBS=ON \
    -DTFLITE_ENABLE_XNNPACK=OFF \
    -DTFLITE_ENABLE_RUY=OFF \
    -DTFLITE_ENABLE_GPU=OFF \
    ${S}/tensorflow/lite/c
}

do_install() {
    # install libraries
    install -d ${D}${libdir}
    install -m 0644 ${B}/libtensorflowlite_c.so ${D}${libdir}
    ln -sfr ${D}/${libdir}/libtensorflowlite_c.so ${D}/${libdir}/libtensorflowlite

    # install header files
    install -d ${D}${includedir}/tensorflow/lite
    cd ${S}/tensorflow/lite
    cp --parents \
        $(find . -name "*.h*") \
        ${D}${includedir}/tensorflow/lite

    # install version.h from core
    install -d ${D}${includedir}/tensorflow/core/public
    cp ${S}/tensorflow/core/public/version.h ${D}${includedir}/tensorflow/core/public

    # flatbuffers
    install -d  ${D}${includedir}/flatbuffers
    install -m 0644 ${B}/flatbuffers/include/flatbuffers/*.h ${D}${includedir}/flatbuffers/
}

FILES_${PN} += "${libdir}/libtensorflow*"
FILES_SOLIBSDEV = ""
